From 8c13153e739afa9d7f2480d1b488ec7c76036802 Mon Sep 17 00:00:00 2001
From: Rich Megginson <rmeggins@redhat.com>
Date: Wed, 9 Sep 2009 17:01:49 -0600
Subject: [PATCH] Add update code - make setup-ds.pl -u do updates
 Updates are implemented in:
 perl - code that plugs in to setup - scriptlets that are imported into
 the setup perl interpreter and executed in process, giving access to all
 of the packages and context provided by setup
 ldif - applied to instances, in the same manner as ConfigFile directives
 to setup
 other - any executable file, shell script, etc. can be invoked, with a limited
 amount of context from the setup process
 An update directory is added to the package - /usr/share/dirsrv/update - this
 directory contains the update files - the update filenames begin with two digits
 and are executed in numeric order (00 first, then 01, etc. up to 99) which
 should provide enough flexibility
 In addition, there are 5 stages of update:
 pre - invoked before any instance specific code
 preinst, runinst, postinst - invoked for each instance
 post - invoked after any instance specific code
 Example files are provided which demonstrate how to get the context.
 There are two different modes of operation for update:
 online - must supply a bind dn and password for each instance - servers must
 be up and running
 offline - operates directly on the dse.ldif - servers must be shutdown first
 A new section is added to the .inf file that can be passed in

[slapd-instancename]
RootDN = binddn
RootDNPwd = bindpw

The RootDN is optional - if not supplied, it will get the nsslapd-rootdn attribute from the dse.ldif for the instance.
I also fixed some problems with error messages.
The pam pta plugin entry was giving object class violations, so I added the
missing attributes - note that these are replaced by the plugin code when
the plugin is loaded - they are only needed during setup.

Fixed usage of $_ - $_ behaves like a dynamically scoped variable - which
means if you use it in an outer context, you cannot use it in an inner
context, even if it is used in a different function.  Rather than attempting
to figure out how to use $_ safely in lower level functions, I just removed
the use of it altogether, which also makes the code easier to read.
---
 Makefile.am                                        |   51 ++-
 Makefile.in                                        |  131 +++++-
 configure                                          |   28 +-
 configure.ac                                       |    7 +-
 .../src/scripts/50addchainingsaslpwroles.ldif      |    6 +
 .../admin/src/scripts/50bitstringsyntaxplugin.ldif |   14 +
 .../src/scripts/50deliverymethodsyntaxplugin.ldif  |   14 +
 ldap/admin/src/scripts/50derefplugin.ldif          |   16 +
 .../src/scripts/50disableurisyntaxplugin.ldif      |    9 +
 .../src/scripts/50enhancedguidesyntaxplugin.ldif   |   14 +
 ldap/admin/src/scripts/50entryusnindex.ldif        |    7 +
 .../admin/src/scripts/50faxnumbersyntaxplugin.ldif |   14 +
 ldap/admin/src/scripts/50faxsyntaxplugin.ldif      |   14 +
 ldap/admin/src/scripts/50guidesyntaxplugin.ldif    |   14 +
 ldap/admin/src/scripts/50linkedattrsplugin.ldif    |   16 +
 ldap/admin/src/scripts/50memberofindex.ldif        |    6 +
 ldap/admin/src/scripts/50memberofplugin.ldif       |   17 +
 ldap/admin/src/scripts/50nameuidsyntaxplugin.ldif  |   14 +
 .../src/scripts/50numericstringsyntaxplugin.ldif   |   14 +
 .../src/scripts/50printablestringsyntaxplugin.ldif |   14 +
 ldap/admin/src/scripts/50schemareloadplugin.ldif   |   14 +
 ldap/admin/src/scripts/50syntaxvalidplugin.ldif    |   14 +
 .../scripts/50teletexterminalidsyntaxplugin.ldif   |   14 +
 .../src/scripts/50telexnumbersyntaxplugin.ldif     |   14 +
 ldap/admin/src/scripts/50usnplugin.ldif            |   15 +
 ldap/admin/src/scripts/60upgradeschemafiles.pl     |   54 ++
 ldap/admin/src/scripts/DSCreate.pm.in              |   51 ++-
 ldap/admin/src/scripts/DSUpdate.pm.in              |  505 ++++++++++++++++++++
 ldap/admin/src/scripts/DSUpdateDialogs.pm          |  181 +++++++
 ldap/admin/src/scripts/FileConn.pm                 |   20 +-
 ldap/admin/src/scripts/Inf.pm                      |   27 +-
 ldap/admin/src/scripts/Resource.pm                 |   17 +-
 ldap/admin/src/scripts/Setup.pm.in                 |   44 ++-
 ldap/admin/src/scripts/Util.pm.in                  |   41 +-
 ldap/admin/src/scripts/dnaplugindepends.ldif       |    4 +
 ldap/admin/src/scripts/dsupdate.map.in             |   65 +++
 ldap/admin/src/scripts/exampleupdate.ldif          |   40 ++
 ldap/admin/src/scripts/exampleupdate.pl            |   56 +++
 ldap/admin/src/scripts/exampleupdate.sh            |   63 +++
 ldap/admin/src/scripts/migrate-ds.res              |    1 -
 ldap/admin/src/scripts/setup-ds.pl.in              |   47 ++-
 ldap/admin/src/scripts/setup-ds.res.in             |   45 ++
 ldap/ldif/template-pampta.ldif.in                  |    6 +-
 43 files changed, 1628 insertions(+), 130 deletions(-)
 create mode 100644 ldap/admin/src/scripts/50addchainingsaslpwroles.ldif
 create mode 100644 ldap/admin/src/scripts/50bitstringsyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50deliverymethodsyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50derefplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50disableurisyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50enhancedguidesyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50entryusnindex.ldif
 create mode 100644 ldap/admin/src/scripts/50faxnumbersyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50faxsyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50guidesyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50linkedattrsplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50memberofindex.ldif
 create mode 100644 ldap/admin/src/scripts/50memberofplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50nameuidsyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50numericstringsyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50printablestringsyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50schemareloadplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50syntaxvalidplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50teletexterminalidsyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50telexnumbersyntaxplugin.ldif
 create mode 100644 ldap/admin/src/scripts/50usnplugin.ldif
 create mode 100644 ldap/admin/src/scripts/60upgradeschemafiles.pl
 create mode 100644 ldap/admin/src/scripts/DSUpdate.pm.in
 create mode 100644 ldap/admin/src/scripts/DSUpdateDialogs.pm
 create mode 100644 ldap/admin/src/scripts/dnaplugindepends.ldif
 create mode 100644 ldap/admin/src/scripts/dsupdate.map.in
 create mode 100644 ldap/admin/src/scripts/exampleupdate.ldif
 create mode 100644 ldap/admin/src/scripts/exampleupdate.pl
 create mode 100644 ldap/admin/src/scripts/exampleupdate.sh

diff --git a/Makefile.am b/Makefile.am
index 665b1f4..ade0d66 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -69,6 +69,7 @@ CLEANFILES =  dberrstrs.h ns-slapd.properties \
 	ldap/admin/src/scripts/template-dbverify ldap/admin/src/template-initconfig \
 	ldap/admin/src/scripts/dscreate.map ldap/admin/src/scripts/remove-ds.pl \
 	ldap/admin/src/scripts/DSCreate.pm ldap/admin/src/scripts/DSMigration.pm \
+	ldap/admin/src/scripts/DSUpdate.pm ldap/admin/src/scripts/dsupdate.map \
 	ldap/admin/src/scripts/dsorgentries.map ldap/admin/src/scripts/migrate-ds.pl \
 	ldap/admin/src/scripts/Migration.pm ldap/admin/src/scripts/SetupDialogs.pm \
 	ldap/admin/src/scripts/setup-ds.pl ldap/admin/src/scripts/setup-ds.res \
@@ -128,6 +129,7 @@ perldir = $(libdir)@perldir@
 infdir = $(datadir)@infdir@
 mibdir = $(datadir)@mibdir@
 policydir = $(datadir)/selinux/targeted
+updatedir = $(datadir)@updatedir@
 
 defaultuser=@defaultuser@
 defaultgroup=@defaultgroup@
@@ -307,7 +309,9 @@ perl_DATA = ldap/admin/src/scripts/SetupLog.pm \
 	ldap/admin/src/scripts/Migration.pm \
 	ldap/admin/src/scripts/DSMigration.pm \
 	ldap/admin/src/scripts/FileConn.pm \
-	ldap/admin/src/scripts/DSCreate.pm
+	ldap/admin/src/scripts/DSCreate.pm \
+	ldap/admin/src/scripts/DSUpdate.pm \
+	ldap/admin/src/scripts/DSUpdateDialogs.pm
 
 property_DATA = ldap/admin/src/scripts/setup-ds.res \
 	ldap/admin/src/scripts/migrate-ds.res
@@ -349,6 +353,7 @@ initconfig_DATA = ldap/admin/src/$(PACKAGE_NAME)
 
 inf_DATA = ldap/admin/src/slapd.inf \
 	ldap/admin/src/scripts/dscreate.map \
+	ldap/admin/src/scripts/dsupdate.map \
 	ldap/admin/src/scripts/dsorgentries.map
 
 mib_DATA = ldap/servers/snmp/RFC-1215.txt \
@@ -381,6 +386,44 @@ dist_man_MANS = man/man1/dbscan.1 \
         man/man8/setup-ds.pl.8 \
 	man/man8/remove-ds.pl.8
 
+#------------------------
+# updates
+# the first 3 are just the examples provided - since they
+# do not begin with two digits, they will be ignored
+# the remaining items should begin with two digits that
+# correspond to the order in which they should be applied
+# perl files and LDIF files are DATA - not executable
+# processed by the update script
+# shell scripts and other files are SCRIPTS - executable
+#------------------------
+update_DATA = ldap/admin/src/scripts/exampleupdate.pl \
+	ldap/admin/src/scripts/exampleupdate.ldif \
+	ldap/admin/src/scripts/50addchainingsaslpwroles.ldif \
+	ldap/admin/src/scripts/50memberofindex.ldif \
+	ldap/admin/src/scripts/50bitstringsyntaxplugin.ldif \
+	ldap/admin/src/scripts/50memberofplugin.ldif \
+	ldap/admin/src/scripts/50deliverymethodsyntaxplugin.ldif \
+	ldap/admin/src/scripts/50nameuidsyntaxplugin.ldif \
+	ldap/admin/src/scripts/50derefplugin.ldif \
+	ldap/admin/src/scripts/50numericstringsyntaxplugin.ldif \
+	ldap/admin/src/scripts/50disableurisyntaxplugin.ldif \
+	ldap/admin/src/scripts/50printablestringsyntaxplugin.ldif \
+	ldap/admin/src/scripts/50enhancedguidesyntaxplugin.ldif \
+	ldap/admin/src/scripts/50schemareloadplugin.ldif \
+	ldap/admin/src/scripts/50entryusnindex.ldif \
+	ldap/admin/src/scripts/50syntaxvalidplugin.ldif \
+	ldap/admin/src/scripts/50faxnumbersyntaxplugin.ldif \
+	ldap/admin/src/scripts/50teletexterminalidsyntaxplugin.ldif \
+	ldap/admin/src/scripts/50faxsyntaxplugin.ldif \
+	ldap/admin/src/scripts/50telexnumbersyntaxplugin.ldif \
+	ldap/admin/src/scripts/50guidesyntaxplugin.ldif \
+	ldap/admin/src/scripts/50linkedattrsplugin.ldif \
+	ldap/admin/src/scripts/50usnplugin.ldif \
+	ldap/admin/src/scripts/60upgradeschemafiles.pl \
+	ldap/admin/src/scripts/dnaplugindepends.ldif
+
+update_SCRIPTS = ldap/admin/src/scripts/exampleupdate.sh
+
 #////////////////////////////////////////////////////////////////
 #
 #   Server Strings
@@ -1249,7 +1292,8 @@ fixupcmd = sed \
 	-e 's,@with_fhs_opt\@,@with_fhs_opt@,g' \
 	-e 's,@with_selinux\@,@with_selinux@,g' \
 	-e 's,@perlexec\@,@perlexec@,g' \
-	-e 's,@initconfigdir\@,$(initconfigdir),g'
+	-e 's,@initconfigdir\@,$(initconfigdir),g'\
+	-e 's,@updatedir\@,$(updatedir),g'
 else
 fixupcmd = sed \
 	-e 's,@bindir\@,$(bindir),g' \
@@ -1301,7 +1345,8 @@ fixupcmd = sed \
 	-e 's,@with_fhs_opt\@,@with_fhs_opt@,g' \
 	-e 's,@with_selinux\@,@with_selinux@,g' \
 	-e 's,@perlexec\@,@perlexec@,g' \
-	-e 's,@initconfigdir\@,$(initconfigdir),g'
+	-e 's,@initconfigdir\@,$(initconfigdir),g' \
+	-e 's,@updatedir\@,$(updatedir),g'
 endif
 
 %: %.in
diff --git a/configure.ac b/configure.ac
index b886643..0e32cd8 100644
--- a/configure.ac
+++ b/configure.ac
@@ -2,7 +2,7 @@
 # Process this file with autoconf to produce a configure script.
 AC_PREREQ(2.59)
 # This version is the version returned by ns-slapd -v
-AC_INIT([dirsrv], [1.2.2], [http://bugzilla.redhat.com/])
+AC_INIT([dirsrv], [1.2.3], [http://bugzilla.redhat.com/])
 # AC_CONFIG_HEADER must be called right after AC_INIT.
 AC_CONFIG_HEADERS([config.h])
 AM_INIT_AUTOMAKE([1.9 foreign subdir-objects])
@@ -205,6 +205,8 @@ if test "$with_fhs_opt" = "yes"; then
   sampledatadir=/data
   # relative to datadir
   scripttemplatedir=/script-templates
+  # relative to datadir
+  updatedir=/updates
   # relative to libdir
   serverdir=
   # relative to libdir
@@ -231,6 +233,8 @@ else
   sampledatadir=/$PACKAGE_NAME/data
   # relative to datadir
   scripttemplatedir=/$PACKAGE_NAME/script-templates
+  # relative to datadir
+  updatedir=/$PACKAGE_NAME/updates
   # relative to libdir
   serverdir=/$PACKAGE_NAME
   # relative to libdir
@@ -272,6 +276,7 @@ AC_SUBST(perldir)
 AC_SUBST(infdir)
 AC_SUBST(mibdir)
 AC_SUBST(mandir)
+AC_SUBST(updatedir)
 
 AC_SUBST(defaultuser)
 AC_SUBST(defaultgroup)
diff --git a/ldap/admin/src/scripts/50addchainingsaslpwroles.ldif b/ldap/admin/src/scripts/50addchainingsaslpwroles.ldif
new file mode 100644
index 0000000..07ee93a
--- /dev/null
+++ b/ldap/admin/src/scripts/50addchainingsaslpwroles.ldif
@@ -0,0 +1,6 @@
+dn: cn=config,cn=chaining database,cn=plugins,cn=config
+changetype: modify
+add: nsPossibleChainingComponents
+nsPossibleChainingComponents: cn=password policy,cn=components,cn=config
+nsPossibleChainingComponents: cn=sasl,cn=components,cn=config
+nsPossibleChainingComponents: cn=roles,cn=components,cn=config
diff --git a/ldap/admin/src/scripts/50bitstringsyntaxplugin.ldif b/ldap/admin/src/scripts/50bitstringsyntaxplugin.ldif
new file mode 100644
index 0000000..8091630
--- /dev/null
+++ b/ldap/admin/src/scripts/50bitstringsyntaxplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Bit String Syntax,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Bit String
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: bitstring_init
+nsslapd-plugintype: syntax
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50deliverymethodsyntaxplugin.ldif b/ldap/admin/src/scripts/50deliverymethodsyntaxplugin.ldif
new file mode 100644
index 0000000..0103c5b
--- /dev/null
+++ b/ldap/admin/src/scripts/50deliverymethodsyntaxplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Delivery Method Syntax,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Delivery Method Syntax
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: delivery_init
+nsslapd-plugintype: syntax
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50derefplugin.ldif b/ldap/admin/src/scripts/50derefplugin.ldif
new file mode 100644
index 0000000..decadac
--- /dev/null
+++ b/ldap/admin/src/scripts/50derefplugin.ldif
@@ -0,0 +1,16 @@
+dn: cn=deref,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+objectclass: nsContainer
+cn: deref
+nsslapd-pluginpath: libderef-plugin
+nsslapd-plugininitfunc: deref_init
+nsslapd-plugintype: preoperation
+nsslapd-pluginenabled: on
+nsslapd-plugin-depends-on-type: database
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50disableurisyntaxplugin.ldif b/ldap/admin/src/scripts/50disableurisyntaxplugin.ldif
new file mode 100644
index 0000000..2838036
--- /dev/null
+++ b/ldap/admin/src/scripts/50disableurisyntaxplugin.ldif
@@ -0,0 +1,9 @@
+dn: cn=URI Syntax,cn=plugins,cn=config
+changetype: modify
+replace: nsslapd-pluginenabled
+nsslapd-pluginenabled: off
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50enhancedguidesyntaxplugin.ldif b/ldap/admin/src/scripts/50enhancedguidesyntaxplugin.ldif
new file mode 100644
index 0000000..b5f8ddc
--- /dev/null
+++ b/ldap/admin/src/scripts/50enhancedguidesyntaxplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Enhanced Guide Syntax,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Enhanced Guide Syntax
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: enhancedguide_init
+nsslapd-plugintype: syntax
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50entryusnindex.ldif b/ldap/admin/src/scripts/50entryusnindex.ldif
new file mode 100644
index 0000000..9196f67
--- /dev/null
+++ b/ldap/admin/src/scripts/50entryusnindex.ldif
@@ -0,0 +1,7 @@
+dn: cn=entryusn,cn=default indexes, cn=config,cn=ldbm database,cn=plugins,cn=config
+objectclass: top
+objectclass: nsIndex
+cn: entryusn
+nssystemindex: true
+nsindextype: eq
+nsmatchingrule: integerOrderingMatch
diff --git a/ldap/admin/src/scripts/50faxnumbersyntaxplugin.ldif b/ldap/admin/src/scripts/50faxnumbersyntaxplugin.ldif
new file mode 100644
index 0000000..1959cd3
--- /dev/null
+++ b/ldap/admin/src/scripts/50faxnumbersyntaxplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Facsimile Telephone Number Syntax,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Facsimile Telephone Number Syntax
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: facsimile_init
+nsslapd-plugintype: syntax
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50faxsyntaxplugin.ldif b/ldap/admin/src/scripts/50faxsyntaxplugin.ldif
new file mode 100644
index 0000000..3410c32
--- /dev/null
+++ b/ldap/admin/src/scripts/50faxsyntaxplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Fax Syntax,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Fax Syntax
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: fax_init
+nsslapd-plugintype: syntax
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50guidesyntaxplugin.ldif b/ldap/admin/src/scripts/50guidesyntaxplugin.ldif
new file mode 100644
index 0000000..d9c3a08
--- /dev/null
+++ b/ldap/admin/src/scripts/50guidesyntaxplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Guide Syntax,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Guide Syntax
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: guide_init
+nsslapd-plugintype: syntax
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50linkedattrsplugin.ldif b/ldap/admin/src/scripts/50linkedattrsplugin.ldif
new file mode 100644
index 0000000..a321673
--- /dev/null
+++ b/ldap/admin/src/scripts/50linkedattrsplugin.ldif
@@ -0,0 +1,16 @@
+dn: cn=Linked Attributes,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+objectclass: nsContainer
+cn: Linked Attributes
+nsslapd-pluginpath: liblinkedattrs-plugin
+nsslapd-plugininitfunc: linked_attrs_init
+nsslapd-plugintype: preoperation
+nsslapd-pluginenabled: on
+nsslapd-plugin-depends-on-type: database
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50memberofindex.ldif b/ldap/admin/src/scripts/50memberofindex.ldif
new file mode 100644
index 0000000..6ede083
--- /dev/null
+++ b/ldap/admin/src/scripts/50memberofindex.ldif
@@ -0,0 +1,6 @@
+dn: cn=memberOf,cn=default indexes, cn=config,cn=ldbm database,cn=plugins,cn=config
+objectclass: top
+objectclass: nsIndex
+cn: memberOf
+nssystemindex: false
+nsindextype: eq
diff --git a/ldap/admin/src/scripts/50memberofplugin.ldif b/ldap/admin/src/scripts/50memberofplugin.ldif
new file mode 100644
index 0000000..722e943
--- /dev/null
+++ b/ldap/admin/src/scripts/50memberofplugin.ldif
@@ -0,0 +1,17 @@
+dn: cn=MemberOf Plugin,cn=plugins,cn=config
+objectClass: top
+objectClass: nsSlapdPlugin
+objectClass: extensibleObject
+cn: MemberOf Plugin
+nsslapd-pluginpath: libmemberof-plugin
+nsslapd-plugininitfunc: memberof_postop_init
+nsslapd-plugintype: postoperation
+nsslapd-pluginenabled: off
+nsslapd-plugin-depends-on-type: database
+memberOfGroupAttr: member
+memberOfAttr: memberOf
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50nameuidsyntaxplugin.ldif b/ldap/admin/src/scripts/50nameuidsyntaxplugin.ldif
new file mode 100644
index 0000000..f4a3305
--- /dev/null
+++ b/ldap/admin/src/scripts/50nameuidsyntaxplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Name And Optional UID Syntax,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Name And Optional UID Syntax
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: nameoptuid_init
+nsslapd-plugintype: syntax
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50numericstringsyntaxplugin.ldif b/ldap/admin/src/scripts/50numericstringsyntaxplugin.ldif
new file mode 100644
index 0000000..a5ba17f
--- /dev/null
+++ b/ldap/admin/src/scripts/50numericstringsyntaxplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Numeric String Syntax,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Numeric String Syntax
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: numstr_init
+nsslapd-plugintype: syntax
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50printablestringsyntaxplugin.ldif b/ldap/admin/src/scripts/50printablestringsyntaxplugin.ldif
new file mode 100644
index 0000000..d8dad9b
--- /dev/null
+++ b/ldap/admin/src/scripts/50printablestringsyntaxplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Printable String Syntax,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Printable String Syntax
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: printable_init
+nsslapd-plugintype: syntax
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50schemareloadplugin.ldif b/ldap/admin/src/scripts/50schemareloadplugin.ldif
new file mode 100644
index 0000000..b6d12a5
--- /dev/null
+++ b/ldap/admin/src/scripts/50schemareloadplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Schema Reload,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Schema Reload
+nsslapd-pluginpath: libschemareload-plugin
+nsslapd-plugininitfunc: schemareload_init
+nsslapd-plugintype: object
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50syntaxvalidplugin.ldif b/ldap/admin/src/scripts/50syntaxvalidplugin.ldif
new file mode 100644
index 0000000..ee0a085
--- /dev/null
+++ b/ldap/admin/src/scripts/50syntaxvalidplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Syntax Validation Task,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Syntax Validation Task
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: syntax_validate_task_init
+nsslapd-plugintype: object
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50teletexterminalidsyntaxplugin.ldif b/ldap/admin/src/scripts/50teletexterminalidsyntaxplugin.ldif
new file mode 100644
index 0000000..ae16488
--- /dev/null
+++ b/ldap/admin/src/scripts/50teletexterminalidsyntaxplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Teletex Terminal Identifier Syntax,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Teletex Terminal Identifier Syntax
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: teletex_init
+nsslapd-plugintype: syntax
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50telexnumbersyntaxplugin.ldif b/ldap/admin/src/scripts/50telexnumbersyntaxplugin.ldif
new file mode 100644
index 0000000..cf28820
--- /dev/null
+++ b/ldap/admin/src/scripts/50telexnumbersyntaxplugin.ldif
@@ -0,0 +1,14 @@
+dn: cn=Telex Number Syntax,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: Telex Number Syntax
+nsslapd-pluginpath: libsyntax-plugin
+nsslapd-plugininitfunc: telex_init
+nsslapd-plugintype: syntax
+nsslapd-pluginenabled: on
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/50usnplugin.ldif b/ldap/admin/src/scripts/50usnplugin.ldif
new file mode 100644
index 0000000..5fd2cfb
--- /dev/null
+++ b/ldap/admin/src/scripts/50usnplugin.ldif
@@ -0,0 +1,15 @@
+dn: cn=USN,cn=plugins,cn=config
+objectclass: top
+objectclass: nsSlapdPlugin
+objectclass: extensibleObject
+cn: USN
+nsslapd-pluginpath: libusn-plugin
+nsslapd-plugininitfunc: usn_init
+nsslapd-plugintype: object
+nsslapd-pluginenabled: off
+nsslapd-plugin-depends-on-type: database
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
diff --git a/ldap/admin/src/scripts/60upgradeschemafiles.pl b/ldap/admin/src/scripts/60upgradeschemafiles.pl
new file mode 100644
index 0000000..b0f5758
--- /dev/null
+++ b/ldap/admin/src/scripts/60upgradeschemafiles.pl
@@ -0,0 +1,54 @@
+
+use DSCreate qw(installSchema);
+
+sub runinst {
+    my ($inf, $inst, $dseldif, $conn) = @_;
+
+    if (!$inf->{slapd}->{schema_dir} or (! -d $inf->{slapd}->{schema_dir})) {
+        return ('error_reading_schema_dir', $inf->{slapd}->{schema_dir});
+    }
+
+    # these schema files are obsolete, or we want to replace
+    # them with newer versions
+    my @toremove = qw(00core.ldif 01common.ldif 05rfc2247.ldif 10presence.ldif 28pilot.ldif 50ns-directory.ldif 60mozilla.ldif);
+
+    # make a backup directory to store the deleted schema, then
+    # don't really delete it, just move it to that directory
+    my $mode = (stat($inf->{slapd}->{schema_dir}))[2];
+    my $bakdir = $inf->{slapd}->{schema_dir} . ".bak";
+    if (! -d $bakdir) {
+        $! = 0; # clear
+        mkdir $bakdir, $mode;
+        if ($!) {
+            return ('error_creating_directory', $bakdir, $!);
+        }
+    }
+
+    my @errs;
+    for my $file (@toremove) {
+        my $oldname = $inf->{slapd}->{schema_dir} . "/" . $file;
+        next if (! -f $oldname); # does not exist - skip - already (re)moved
+        my $newname = "$bakdir/$file";
+        $! = 0; # clear
+        rename $oldname, $newname;
+        if ($!) {
+            push @errs, ["error_renaming_schema", $oldname, $newname, $!];
+        }
+    }
+
+    if (@errs) { # errors backing up schema
+        # restore the original schema files
+        for my $file (@toremove) {
+            my $oldname = "$bakdir/$file";
+            next if (! -f $oldname); # does not exist - not backed up
+            my $newname = $inf->{slapd}->{schema_dir} . "/" . $file;
+            next if (-f $newname); # not removed
+            rename $oldname, $newname;
+        }
+        return @errs;
+    }
+
+    # after removing them, just add everything in the default
+    # schema directory
+    return installSchema($inf, 1);
+}
